<?php

namespace Jlr\Tags\Api\Model;

class Tag
{
    /**
     * 
     *
     * @var string
     */
    protected $id;
    /**
     * 
     *
     * @var string
     */
    protected $name;
    /**
     * 
     *
     * @var bool
     */
    protected $userGenerated;
    /**
     * 
     *
     * @var string
     */
    protected $description;
    /**
     * This is what ever custom content has been saved by the applications. In most situations this should be an array but theoretically it could be anything.
     *
     * @var mixed
     */
    protected $meta;
    /**
     * 
     *
     * @var Tag[]
     */
    protected $children;
    /**
     * 
     *
     * @var TagGroup
     */
    protected $group;
    /**
     * An array of all the slugs this tag should be related to.
     *
     * @var string[]
     */
    protected $childSlugs;
    /**
     * The group id this slug should be associated to.
     *
     * @var int
     */
    protected $groupId;
    /**
     * 
     *
     * @return string
     */
    public function getId() : ?string
    {
        return $this->id;
    }
    /**
     * 
     *
     * @param string $id
     *
     * @return self
     */
    public function setId(?string $id) : self
    {
        $this->id = $id;
        return $this;
    }
    /**
     * 
     *
     * @return string
     */
    public function getName() : ?string
    {
        return $this->name;
    }
    /**
     * 
     *
     * @param string $name
     *
     * @return self
     */
    public function setName(?string $name) : self
    {
        $this->name = $name;
        return $this;
    }
    /**
     * 
     *
     * @return bool
     */
    public function getUserGenerated() : ?bool
    {
        return $this->userGenerated;
    }
    /**
     * 
     *
     * @param bool $userGenerated
     *
     * @return self
     */
    public function setUserGenerated(?bool $userGenerated) : self
    {
        $this->userGenerated = $userGenerated;
        return $this;
    }
    /**
     * 
     *
     * @return string
     */
    public function getDescription() : ?string
    {
        return $this->description;
    }
    /**
     * 
     *
     * @param string $description
     *
     * @return self
     */
    public function setDescription(?string $description) : self
    {
        $this->description = $description;
        return $this;
    }
    /**
     * This is what ever custom content has been saved by the applications. In most situations this should be an array but theoretically it could be anything.
     *
     * @return mixed
     */
    public function getMeta()
    {
        return $this->meta;
    }
    /**
     * This is what ever custom content has been saved by the applications. In most situations this should be an array but theoretically it could be anything.
     *
     * @param mixed $meta
     *
     * @return self
     */
    public function setMeta($meta) : self
    {
        $this->meta = $meta;
        return $this;
    }
    /**
     * 
     *
     * @return Tag[]
     */
    public function getChildren() : ?array
    {
        return $this->children;
    }
    /**
     * 
     *
     * @param Tag[] $children
     *
     * @return self
     */
    public function setChildren(?array $children) : self
    {
        $this->children = $children;
        return $this;
    }
    /**
     * 
     *
     * @return TagGroup
     */
    public function getGroup() : ?TagGroup
    {
        return $this->group;
    }
    /**
     * 
     *
     * @param TagGroup $group
     *
     * @return self
     */
    public function setGroup(?TagGroup $group) : self
    {
        $this->group = $group;
        return $this;
    }
    /**
     * An array of all the slugs this tag should be related to.
     *
     * @return string[]
     */
    public function getChildSlugs() : ?array
    {
        return $this->childSlugs;
    }
    /**
     * An array of all the slugs this tag should be related to.
     *
     * @param string[] $childSlugs
     *
     * @return self
     */
    public function setChildSlugs(?array $childSlugs) : self
    {
        $this->childSlugs = $childSlugs;
        return $this;
    }
    /**
     * The group id this slug should be associated to.
     *
     * @return int
     */
    public function getGroupId() : ?int
    {
        return $this->groupId;
    }
    /**
     * The group id this slug should be associated to.
     *
     * @param int $groupId
     *
     * @return self
     */
    public function setGroupId(?int $groupId) : self
    {
        $this->groupId = $groupId;
        return $this;
    }
}